{**********************************************************}
{*                    BDSLIB v1.3                         *}
{*               Base64 Code/Encode unit                  *}
{*           (Turbo/Borland Pascal version)               *}
{*    (c) 1997-2000 by Dmitry Beloshistov [-=BDS=-]       *}
{*        Fido: 2:465/168.10 AKA 2:465/107.31             *}
{*          e-mail: torin@kerin.donetsk.ua                *}
{**********************************************************}
Unit Base64;
Interface

 Procedure CodeBase64  (InFile,OutFile:String);
 Procedure DeCodeBase64(InFile,OutFile:String);

Implementation
Uses Dos;

Procedure CodeBase64(InFile,OutFile:String);
var  w:word;
     c:char;
     l,k:byte;
     F1,F2:Text;
     Base64Str:String;
begin
 Base64Str:='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
 assign(F1,InFile);  reset(F1);
 assign(F2,OutFile); rewrite(F2);
 w:=0; l:=0; k:=0;
 while not eof(F1) do
  begin
   read(F1,c); w:=w or ((w or ord(c)) shl (8-l)); inc(l,8);
   while l>= 6 do
    begin
     write(F2,Base64Str[hi(w shr 2)+1]);
     inc(k);
     if k = 60 then begin writeln(F2,'');  k:=0; end;
     w:=w shl 6;
     dec(l,6);
    end;
  end;
 if l > 0 then write(F2,Base64Str[hi(w shr(8-l))+1]);
 Close(F1); Close(F2);
end;

Procedure DeCodeBase64(InFile,OutFile:String);
var Base64:array[43..122] of byte;
    T:text;
    Chars:set of char;
    S:string;
    K,I,J:word;
    Buf:pointer;
    DShift:integer;
    F:file;
    B,B1:byte;
    Decode:array[0..63] of byte;
    Shift2:byte;
    Size,W:word;
begin
 FillChar(Base64,SizeOf(Base64),255);
 J:=0;
 for I:=65 to 90 do begin Base64[I]:=J; Inc(J); end;
 for I:=97 to 122 do begin Base64[I]:=J; Inc(J); end;
 for I:=48 to 57 do begin Base64[I]:=J; Inc(J); end;
 Base64[43]:=J; Inc(J); Base64[47]:=J; Inc(J);
 assign(T,InFile);
 GetMem(Buf,32768);
 SetTextBuf(T,Buf^,32768);
 {$I-} reset(T); {$I+}
 assign(F,OutFile);
 {$I-} rewrite(F,1); {$I+}
 while not eof(T) do
  begin
   ReadLn(T,S);
   if (S<>'') and (pos(' ',S)=0) and (S[1]>=#43) and (S[1]<=#122) and
      (Base64[byte(S[1])]<>255) then
    begin
     FillChar(Decode,SizeOf(Decode),0);
     DShift:=0; J:=0; Shift2:=1; Size:=255; B:=0;
     for I:=1 to Length(S) do
      begin
       case S[I] of
        #43..#122:B1:=Base64[Ord(S[I])];
        else B1:=255;
       end;
       if B1=255 then
        if S[I]='=' then begin B1:=0; if Size=255 then Size:=J; end;
       if (DShift and 7)=0 then
          begin  Decode[J]:=byte(B1 shl 2); DShift:=2; end
       else begin
             Decode[J]:=Decode[J] or Hi(word(B1) shl (DShift+2));
             Decode[J+1]:=Lo(word(B1) shl (DShift+2));
             Inc(J); Inc(DShift,2);
           end;
      end;
     if Size=255 then Size:=J;
     BlockWrite(F,Decode,Size);
    end;
  end;
 Close(F);
 close(T);
end;

End.
